

// Test Cholesky module

#include <iostream.h>

#include "tnt.h"
#include "vec.h"
#include "cmat.h"
#include "cholesky.h"
#include "trislv.h"
#include "transv.h"         /* tranpose views */

main()
{
    C_matrix<double> A;

    cin >> A;

    Subscript N = A.num_rows();
    assert(N == A.num_cols());

    Vector<double> b(N, 1.0);   // b= [1,1,1,...]
    C_matrix<double> L(N, N);

    cerr << "A: " << A << endl;
    
    if (Cholesky_upper_factorization(A, L) !=0)
    {
        cerr << "Cholesky did not work." << endl;
        exit(1);
    }
    

    cerr << L << endl;

    // solve Ax =b, as L*L'x =b
    //
    //  let y=L'x, then
    //
    //
    //   solve L y = b;
    //   solve L'x = y;

    Vector<double> y = Lower_triangular_solve(L, b);
    Vector<double> x= Upper_triangular_solve(Transpose_view(L), y);

    cerr << "x: " << x << endl;
    cerr << "Residual A*x-b: " << A*x-b << endl;
}
