
#include "btl/VoidPtrStore.h"
#include "btl/BTL.h"

#if !defined(SGI_CC)
#include <vector>
#else
#include <vector.h>
#endif

#if !defined(SGI_CC) && !defined(GCC_272)
using namespace std;
#endif

int main()
{
    typedef int     	    	    value_type;
    typedef BTL_PtrSet<value_type>  container;
    typedef BTL_II<value_type>	    iterator;
    typedef BTL_CII<value_type>      const_iterator;
    
{    
    // Create an array of int's.
    //
    int size=7;
    value_type data[size];
    for (int i=0; i<size; i++) data[i] = i;
    
    // Store pointers to these int's in a container.
    //
    container ptr_store;
    for (int i=0; i<size; i++) ptr_store.insert(ptr_store.end(),&data[i]);

    // Access this container using a BTL_II
    //
    iterator i1;
    iterator i2();
    
    iterator begin1 = ptr_store.begin();

    iterator begin2(begin1);
    if (!(begin1 == begin2)) FATAL_ERROR("Copy contructor or "
                                         "equality operator error.");
     
    iterator begin3 = begin1;
    if (!(begin1 == begin2)) FATAL_ERROR("Assignment operator error");
    
    if (begin1 != begin3) FATAL_ERROR("Not equals operator error");
    
    i1 = begin1;
    if (!(begin1 == i1)) FATAL_ERROR("Assignment operator error");
    
    int x = *begin1;
    if (x != 0) FATAL_ERROR("Dereference operator error");
    
    ++begin1;
    x = *begin1;
    if (x != 1) FATAL_ERROR("Prefix increment operator error");
    
    if (&begin1 != &++begin1) FATAL_ERROR("Prefix increment operator error");
     
    i1 = begin1; 
    if (++i1 != ++begin1) FATAL_ERROR("Prefix increment operator error");
    
    begin1++;
    if (*begin1 != 4) FATAL_ERROR("Postfix increment operator error");
    
    if (*++begin1 != 5) FATAL_ERROR("Dereferencing or incrementation error");
        
    if (*begin1++ != 5) FATAL_ERROR("Dereferencing or incrementation error");
    
    if (*begin1 != 6) FATAL_ERROR("Dereferencing error");
    
    i1 = --begin1;
    if (*i1 != 5) FATAL_ERROR("Prefix decrement operator error");
    
    if (&begin1 != &--begin1) FATAL_ERROR("Prefix decrement operator error");    
    
    begin1--;
    if (*begin1 != 3) FATAL_ERROR("Postfix decrement operator error");
    
    if (*--begin1 != 2) FATAL_ERROR("Dereferencing or incrementation error");
        
    if (*begin1-- != 2) FATAL_ERROR("Dereferencing or incrementation error");
        
    if (*begin1 != 1) FATAL_ERROR("Dereferencing error");
    
    *begin1 = 99; 
    if (*begin1 != 99) FATAL_ERROR("Dereferencing error");

}
{    
    // Create an array of int's.
    //
    int size=7;
    value_type data[size];
    for (int i=0; i<size; i++) data[i] = i;
    
    // Store pointers to these int's in a container.
    //
    container ptr_store;
    for (int i=0; i<size; i++) ptr_store.insert(ptr_store.end(),&data[i]);
    // Access this container using a BTL_II
    //
    const_iterator i1;
    const_iterator i2();
    
    const_iterator begin1 = ptr_store.begin();

    const_iterator begin2(begin1);
    if (!(begin1 == begin2)) FATAL_ERROR("Copy contructor or "
                                         "equality operator error.");
     
    const_iterator begin3 = begin1;
    if (!(begin1 == begin2)) FATAL_ERROR("Assignment operator error");
    
    if (begin1 != begin3) FATAL_ERROR("Not equals operator error");
    
    i1 = begin1;
    if (!(begin1 == i1)) FATAL_ERROR("Assignment operator error");
    
    int x = *begin1;
    if (x != 0) FATAL_ERROR("Dereference operator error");
    
    ++begin1;
    x = *begin1;
    if (x != 1) FATAL_ERROR("Prefix increment operator error");
    
    if (&begin1 != &++begin1) FATAL_ERROR("Prefix increment operator error");
     
    i1 = begin1; 
    if (++i1 != ++begin1) FATAL_ERROR("Prefix increment operator error");
    
    begin1++;
    if (*begin1 != 4) FATAL_ERROR("Postfix increment operator error");
    
    if (*++begin1 != 5) FATAL_ERROR("Dereferencing or incrementation error");
        
    if (*begin1++ != 5) FATAL_ERROR("Dereferencing or incrementation error");
    
    if (*begin1 != 6) FATAL_ERROR("Dereferencing error");
    
    i1 = --begin1;
    if (*i1 != 5) FATAL_ERROR("Prefix decrement operator error");
    
    if (&begin1 != &--begin1) FATAL_ERROR("Prefix decrement operator error");    
    
    begin1--;
    if (*begin1 != 3) FATAL_ERROR("Postfix decrement operator error");
    
    if (*--begin1 != 2) FATAL_ERROR("Dereferencing or incrementation error");
        
    if (*begin1-- != 2) FATAL_ERROR("Dereferencing or incrementation error");
        
    if (*begin1 != 1) FATAL_ERROR("Dereferencing error");

}    
    return 0;
}
